/**
 * @namespace flexygo.pda
 */
var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        //GENÉRICO: Establece las variables de contexto en el cliente tras loguearse en la PDA.
        pda.afterLogin = (docsesion, almacen, terminal, maquina, descrip, tipomaq) => {
            //Asignación variables de contexto
            flexygo.context.currentIdDocSesion = docsesion;
            flexygo.context.currentIdAlmacen = almacen;
            flexygo.context.currentIdTerminal = terminal;
            flexygo.context.currentMaquina = maquina;
            flexygo.context.currentNombreMaquina = descrip;
            flexygo.context.currentTipoMaquina = tipomaq;
            flexygo.nav.openPageName('syspage-generic-controlpanel', '', '', null, 'main', false, null);
            //Refresco menú
            let node = $(`flx-nav[id="mainNav"]`)[0];
            node.refresh();
        };
        //GENÉRICO: Revisar si hay conexión con el servidor
        pda.OnlineCheck = () => {
            return new Promise(function (resolve, reject) {
                flexygo.ajax.post('~/api/Sys', 'IsConnectionAlive', null, (response) => {
                    if (response) {
                        return resolve();
                    }
                    else {
                        return reject();
                    }
                }, (err) => {
                    return reject();
                });
            });
        };
        pda.replaceEnterToTab = () => {
            let editModule = $('flx-edit').closest('flx-module');
            var dependenciesLoad = setInterval(() => {
                if (editModule.find('#flx-dependency-loader').length === 0) {
                    var focusables = $('flx-edit :focusable, .mobileinput');
                    focusables.off('keydown.changeEnter').on('keydown.changeEnter', function (e) {
                        console.log(e);
                        if (e.key == 'Enter') {
                            var current = $(e.target).closest('div[data-tag="control"] > ');
                            waitToTab(current, false);
                            e.preventDefault();
                            e.stopPropagation();
                        }
                    });
                    clearInterval(dependenciesLoad);
                }
            }, 200);
        };
        const waitToTab = (div, focus) => {
            let flxEdit = $(div).closest('flx-edit');
            var dependenciesLoad = setInterval(() => {
                if (flxEdit.find('.item #flx-dependency-loader, .grid-stack-item #flx-dependency-loader').length === 0) {
                    clearInterval(dependenciesLoad);
                    tabToNext(div, flxEdit, focus);
                }
            }, 200);
        };
        const tabToNext = (div, flxEdit, focus) => {
            let posX, posY;
            div = $(div);
            if (!div.hasClass('grid-stack-item')) {
                div = div.closest('.grid-stack-item');
            }
            posX = div.attr('data-gs-x');
            posY = div.attr('data-gs-y');
            let items = flxEdit.find(':focusable').closest(".grid-stack-item");
            let greaterPositions = items.map(index => {
                let itemXPos = items[index].getAttribute('data-gs-x');
                let itemYPos = items[index].getAttribute('data-gs-y');
                if (itemYPos > posY || (itemYPos === posY && itemXPos > posX)) {
                    return { x: itemXPos, y: itemYPos };
                }
            }).sort(orderStackItems);
            if (greaterPositions.length === 0) {
                pda.replaceEnterToTab();
                flxEdit.closest('flx-module').find(".btn-group").find(".btn:first").focus();
                return;
            }
            let container = $(`[data-gs-x="${greaterPositions[0].x}"][data-gs-y="${greaterPositions[0].y}"]`);
            let input = container.find(':not(flx-dbcombo > div, flx-dbcombo > ul > div) > input:not(.hiddden, .mobileinput, [disabled], .onoffswitch-checkbox), flx-dbcombo:not([disabled]) input[type="search"]:not(.hiddden, [disabled], .onoffswitch-checkbox), select:not(.hiddden), textarea:not(.hiddden, [disabled])');
            if (input.length > 0) {
                if (focus) {
                    if (div.find(".has-error").length == 0) {
                        input.focus();
                        input.select();
                        $(input).animate({ scrollTop: -20 }, 300);
                    }
                    else {
                        div.find("input").focus();
                        div.find("input").select();
                    }
                }
                else {
                    div.find("input").blur();
                    waitToTab(div, true);
                }
            }
            else {
                tabToNext(container, flxEdit, false);
            }
            pda.replaceEnterToTab();
        };
        const orderStackItems = (a, b) => {
            if (a.y > b.y || (a.y === b.y && a.x > b.x)) {
                return 1;
            }
            else {
                return -1;
            }
        };
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=pda.js.map